diff --git a/sbin/fsck_hammer2/test.c b/sbin/fsck_hammer2/test.c
index cdbfb1ab62..35fe451032 100644
--- a/sbin/fsck_hammer2/test.c
+++ b/sbin/fsck_hammer2/test.c
@@ -125,27 +125,26 @@ typedef struct {
 	long count;
 } delta_stats_t;
 
-static void print_blockref_entry(int, struct blockref_tree *);
+static void print_blockref_entry(struct blockref_tree *);
 static void init_blockref_stats(blockref_stats_t *, uint8_t);
 static void cleanup_blockref_stats(blockref_stats_t *);
 static void init_delta_root(struct blockref_tree *);
 static void cleanup_delta_root(struct blockref_tree *);
 static void print_blockref_stats(const blockref_stats_t *, bool);
 static int verify_volume_header(const hammer2_volume_data_t *);
-static int read_media(int, const hammer2_blockref_t *, hammer2_media_data_t *,
+static int read_media(const hammer2_blockref_t *, hammer2_media_data_t *,
     size_t *);
-static int verify_blockref(int, const hammer2_volume_data_t *,
+static int verify_blockref(const hammer2_volume_data_t *,
     const hammer2_blockref_t *, bool, blockref_stats_t *,
     struct blockref_tree *, delta_stats_t *, int, int);
 static void print_pfs(const hammer2_inode_data_t *);
 static char *get_inode_filename(const hammer2_inode_data_t *);
-static int init_pfs_blockref(int, const hammer2_volume_data_t *,
+static int init_pfs_blockref(const hammer2_volume_data_t *,
     const hammer2_blockref_t *, struct blockref_list *);
 static void cleanup_pfs_blockref(struct blockref_list *);
 static void print_media(FILE *, int, const hammer2_blockref_t *,
     const hammer2_media_data_t *, size_t);
 
-static hammer2_off_t volume_size;
 static int best_zone = -1;
 
 #define TAB 8
@@ -189,20 +188,24 @@ tprintf_zone(int tab, int i, const hammer2_blockref_t *bref)
 }
 
 static int
-init_root_blockref(int fd, int i, uint8_t type, hammer2_blockref_t *bref)
+init_root_blockref(int i, uint8_t type, hammer2_blockref_t *bref)
 {
+	hammer2_off_t off;
+
 	assert(type == HAMMER2_BREF_TYPE_EMPTY ||
 		type == HAMMER2_BREF_TYPE_VOLUME ||
 		type == HAMMER2_BREF_TYPE_FREEMAP);
 	memset(bref, 0, sizeof(*bref));
 	bref->type = type;
 	bref->data_off = (i * HAMMER2_ZONE_BYTES64) | HAMMER2_PBUFRADIX;
+	off = bref->data_off & ~HAMMER2_OFF_MASK_RADIX;
 
-	return lseek(fd, bref->data_off & ~HAMMER2_OFF_MASK_RADIX, SEEK_SET);
+	return lseek(hammer2_get_root_volume_fd(),
+	    off - hammer2_get_root_volume_offset(), SEEK_SET);
 }
 
 static int
-find_best_zone(int fd)
+find_best_zone(void)
 {
 	hammer2_blockref_t best;
 	int i, best_i = -1;
@@ -214,10 +217,12 @@ find_best_zone(int fd)
 		hammer2_blockref_t broot;
 		ssize_t ret;
 
-		if (i * HAMMER2_ZONE_BYTES64 >= volume_size)
+		if (i * HAMMER2_ZONE_BYTES64 >=
+		    hammer2_get_root_volume_size())
 			break;
-		init_root_blockref(fd, i, HAMMER2_BREF_TYPE_EMPTY, &broot);
-		ret = read(fd, &voldata, HAMMER2_PBUFSIZE);
+		init_root_blockref(i, HAMMER2_BREF_TYPE_EMPTY, &broot);
+		ret = read(hammer2_get_root_volume_fd(), &voldata,
+		    HAMMER2_PBUFSIZE);
 		if (ret == HAMMER2_PBUFSIZE) {
 			if ((voldata.magic != HAMMER2_VOLUME_ID_HBO) &&
 			    (voldata.magic != HAMMER2_VOLUME_ID_ABO))
@@ -240,7 +245,7 @@ find_best_zone(int fd)
 }
 
 static int
-test_volume_header(int fd)
+test_volume_header(void)
 {
 	bool failed = false;
 	int i;
@@ -252,12 +257,14 @@ test_volume_header(int fd)
 
 		if (ScanBest && i != best_zone)
 			continue;
-		if (i * HAMMER2_ZONE_BYTES64 >= volume_size) {
+		if (i * HAMMER2_ZONE_BYTES64 >=
+		    hammer2_get_root_volume_size()) {
 			tfprintf(stderr, 0, "zone.%d exceeds volume size\n", i);
 			break;
 		}
-		init_root_blockref(fd, i, HAMMER2_BREF_TYPE_EMPTY, &broot);
-		ret = read(fd, &voldata, HAMMER2_PBUFSIZE);
+		init_root_blockref(i, HAMMER2_BREF_TYPE_EMPTY, &broot);
+		ret = read(hammer2_get_root_volume_fd(), &voldata,
+		    HAMMER2_PBUFSIZE);
 		if (ret == HAMMER2_PBUFSIZE) {
 			tprintf_zone(0, i, &broot);
 			if (verify_volume_header(&voldata) == -1)
@@ -275,7 +282,7 @@ test_volume_header(int fd)
 }
 
 static int
-test_blockref(int fd, uint8_t type)
+test_blockref(uint8_t type)
 {
 	struct blockref_tree droot;
 	bool failed = false;
@@ -289,23 +296,25 @@ test_blockref(int fd, uint8_t type)
 
 		if (ScanBest && i != best_zone)
 			continue;
-		if (i * HAMMER2_ZONE_BYTES64 >= volume_size) {
+		if (i * HAMMER2_ZONE_BYTES64 >=
+		    hammer2_get_root_volume_size()) {
 			tfprintf(stderr, 0, "zone.%d exceeds volume size\n", i);
 			break;
 		}
-		init_root_blockref(fd, i, type, &broot);
-		ret = read(fd, &voldata, HAMMER2_PBUFSIZE);
+		init_root_blockref(i, type, &broot);
+		ret = read(hammer2_get_root_volume_fd(), &voldata,
+		    HAMMER2_PBUFSIZE);
 		if (ret == HAMMER2_PBUFSIZE) {
 			blockref_stats_t bstats;
 			init_blockref_stats(&bstats, type);
 			delta_stats_t ds;
 			memset(&ds, 0, sizeof(ds));
 			tprintf_zone(0, i, &broot);
-			if (verify_blockref(fd, &voldata, &broot, false,
-			    &bstats, &droot, &ds, 0, 0) == -1)
+			if (verify_blockref(&voldata, &broot, false, &bstats,
+			    &droot, &ds, 0, 0) == -1)
 				failed = true;
 			print_blockref_stats(&bstats, true);
-			print_blockref_entry(fd, &bstats.root);
+			print_blockref_entry(&bstats.root);
 			cleanup_blockref_stats(&bstats);
 		} else if (ret == -1) {
 			perror("read");
@@ -323,7 +332,7 @@ test_blockref(int fd, uint8_t type)
 }
 
 static int
-test_pfs_blockref(int fd)
+test_pfs_blockref(void)
 {
 	struct blockref_tree droot;
 	uint8_t type = HAMMER2_BREF_TYPE_VOLUME;
@@ -338,12 +347,14 @@ test_pfs_blockref(int fd)
 
 		if (ScanBest && i != best_zone)
 			continue;
-		if (i * HAMMER2_ZONE_BYTES64 >= volume_size) {
+		if (i * HAMMER2_ZONE_BYTES64 >=
+		    hammer2_get_root_volume_size()) {
 			tfprintf(stderr, 0, "zone.%d exceeds volume size\n", i);
 			break;
 		}
-		init_root_blockref(fd, i, type, &broot);
-		ret = read(fd, &voldata, HAMMER2_PBUFSIZE);
+		init_root_blockref(i, type, &broot);
+		ret = read(hammer2_get_root_volume_fd(), &voldata,
+		    HAMMER2_PBUFSIZE);
 		if (ret == HAMMER2_PBUFSIZE) {
 			struct blockref_list blist;
 			struct blockref_msg *p;
@@ -351,8 +362,7 @@ test_pfs_blockref(int fd)
 
 			tprintf_zone(0, i, &broot);
 			TAILQ_INIT(&blist);
-			if (init_pfs_blockref(fd, &voldata, &broot, &blist) ==
-			    -1) {
+			if (init_pfs_blockref(&voldata, &broot, &blist) == -1) {
 				tfprintf(stderr, 1, "Failed to read PFS "
 				    "blockref\n");
 				failed = true;
@@ -390,11 +400,11 @@ test_pfs_blockref(int fd)
 				init_blockref_stats(&bstats, type);
 				delta_stats_t ds;
 				memset(&ds, 0, sizeof(ds));
-				if (verify_blockref(fd, &voldata, &p->bref,
-				    false, &bstats, &droot, &ds, 0, 0) == -1)
+				if (verify_blockref(&voldata, &p->bref, false,
+				    &bstats, &droot, &ds, 0, 0) == -1)
 					failed = true;
 				print_blockref_stats(&bstats, true);
-				print_blockref_entry(fd, &bstats.root);
+				print_blockref_entry(&bstats.root);
 				cleanup_blockref_stats(&bstats);
 			}
 			cleanup_pfs_blockref(&blist);
@@ -538,17 +548,17 @@ print_blockref_debug(FILE *fp, int depth, int index,
 }
 
 static void
-print_blockref_msg(int fd, const struct blockref_list *head)
+print_blockref_msg(const struct blockref_list *head)
 {
 	struct blockref_msg *m;
 
 	TAILQ_FOREACH(m, head, entry) {
 		hammer2_blockref_t *bref = &m->bref;
 		print_blockref(stderr, bref, m->msg);
-		if (fd != -1 && VerboseOpt > 0) {
+		if (VerboseOpt > 0) {
 			hammer2_media_data_t media;
 			size_t bytes;
-			if (!read_media(fd, bref, &media, &bytes))
+			if (!read_media(bref, &media, &bytes))
 				print_media(stderr, 2, bref, &media, bytes);
 			else
 				tfprintf(stderr, 2, "Failed to read media\n");
@@ -557,12 +567,12 @@ print_blockref_msg(int fd, const struct blockref_list *head)
 }
 
 static void
-print_blockref_entry(int fd, struct blockref_tree *root)
+print_blockref_entry(struct blockref_tree *root)
 {
 	struct blockref_entry *e;
 
 	RB_FOREACH(e, blockref_tree, root)
-		print_blockref_msg(fd, &e->head);
+		print_blockref_msg(&e->head);
 }
 
 static void
@@ -684,11 +694,12 @@ verify_volume_header(const hammer2_volume_data_t *voldata)
 }
 
 static int
-read_media(int fd, const hammer2_blockref_t *bref, hammer2_media_data_t *media,
+read_media(const hammer2_blockref_t *bref, hammer2_media_data_t *media,
     size_t *media_bytes)
 {
 	hammer2_off_t io_off, io_base;
 	size_t bytes, io_bytes, boff;
+	int fd;
 
 	bytes = (bref->data_off & HAMMER2_OFF_MASK_RADIX);
 	if (bytes)
@@ -709,7 +720,9 @@ read_media(int fd, const hammer2_blockref_t *bref, hammer2_media_data_t *media,
 
 	if (io_bytes > sizeof(*media))
 		return -1;
-	if (lseek(fd, io_base, SEEK_SET) == -1)
+	fd = hammer2_get_volume_fd(io_off);
+	if (lseek(fd, io_base - hammer2_get_volume_offset(io_base), SEEK_SET)
+	    == -1)
 		return -2;
 	if (read(fd, media, io_bytes) != (ssize_t)io_bytes)
 		return -2;
@@ -764,7 +777,7 @@ accumulate_delta_stats(delta_stats_t *dst, const delta_stats_t *src)
 }
 
 static int
-verify_blockref(int fd, const hammer2_volume_data_t *voldata,
+verify_blockref(const hammer2_volume_data_t *voldata,
     const hammer2_blockref_t *bref, bool norecurse, blockref_stats_t *bstats,
     struct blockref_tree *droot, delta_stats_t *dstats, int depth, int index)
 {
@@ -862,7 +875,7 @@ verify_blockref(int fd, const hammer2_volume_data_t *voldata,
 		break;
 	}
 
-	switch (read_media(fd, bref, &media, &bytes)) {
+	switch (read_media(bref, &media, &bytes)) {
 	case -1:
 		strlcpy(msg, "Bad I/O bytes", sizeof(msg));
 		add_blockref_entry(&bstats->root, bref, msg, strlen(msg) + 1);
@@ -985,8 +998,8 @@ verify_blockref(int fd, const hammer2_volume_data_t *voldata,
 	for (i = 0; norecurse == false && i < bcount; ++i) {
 		delta_stats_t ds;
 		memset(&ds, 0, sizeof(ds));
-		if (verify_blockref(fd, voldata, &bscan[i], failed, bstats,
-		    droot, &ds, depth + 1, i) == -1)
+		if (verify_blockref(voldata, &bscan[i], failed, bstats, droot,
+		    &ds, depth + 1, i) == -1)
 			return -1;
 		if (!failed)
 			accumulate_delta_stats(dstats, &ds);
@@ -1070,7 +1083,7 @@ __add_pfs_blockref(const hammer2_blockref_t *bref, struct blockref_list *blist,
 }
 
 static int
-init_pfs_blockref(int fd, const hammer2_volume_data_t *voldata,
+init_pfs_blockref(const hammer2_volume_data_t *voldata,
     const hammer2_blockref_t *bref, struct blockref_list *blist)
 {
 	hammer2_media_data_t media;
@@ -1079,7 +1092,7 @@ init_pfs_blockref(int fd, const hammer2_volume_data_t *voldata,
 	int i, bcount;
 	size_t bytes;
 
-	if (read_media(fd, bref, &media, &bytes))
+	if (read_media(bref, &media, &bytes))
 		return -1;
 	if (!bytes)
 		return 0;
@@ -1114,7 +1127,7 @@ init_pfs_blockref(int fd, const hammer2_volume_data_t *voldata,
 	}
 
 	for (i = 0; i < bcount; ++i)
-		if (init_pfs_blockref(fd, voldata, &bscan[i], blist) == -1)
+		if (init_pfs_blockref(voldata, &bscan[i], blist) == -1)
 			return -1;
 	return 0;
 }
@@ -1283,111 +1296,52 @@ print_media(FILE *fp, int tab, const hammer2_blockref_t *bref,
 		free(str);
 }
 
-static hammer2_off_t
-check_volume(int fd)
-{
-	struct partinfo pinfo;
-	hammer2_off_t size;
-
-	if (ioctl(fd, DIOCGPART, &pinfo) < 0) {
-		struct stat st;
-		if (fstat(fd, &st) < 0) {
-			perror("fstat");
-			return -1;
-		}
-		if (!S_ISREG(st.st_mode)) {
-			fprintf(stderr, "Unsupported file type\n");
-			return -1;
-		}
-		size = st.st_size;
-	} else {
-		if (pinfo.reserved_blocks) {
-			fprintf(stderr, "HAMMER2 cannot be placed in a "
-			    "partition which overlaps the disklabel or MBR\n");
-			return -1;
-		}
-		if (pinfo.media_blksize > HAMMER2_PBUFSIZE ||
-		    HAMMER2_PBUFSIZE % pinfo.media_blksize) {
-			fprintf(stderr, "A media sector size of %d is not "
-			    "supported\n", pinfo.media_blksize);
-			return -1;
-		}
-		size = pinfo.media_size;
-	}
-	return size;
-}
-
 int
 test_hammer2(const char *devpath)
 {
-	struct stat st;
 	bool failed = false;
-	int fd;
-
-	fd = open(devpath, O_RDONLY);
-	if (fd == -1) {
-		perror("open");
-		return -1;
-	}
 
-	if (fstat(fd, &st) == -1) {
-		perror("fstat");
-		failed = true;
-		goto end;
-	}
-	if (!S_ISCHR(st.st_mode) && !S_ISREG(st.st_mode)) {
-		fprintf(stderr, "Unsupported file type\n");
-		failed = true;
-		goto end;
-	}
-
-	volume_size = check_volume(fd);
-	if (volume_size == (hammer2_off_t)-1) {
-		fprintf(stderr, "Failed to find volume size\n");
-		failed = true;
-		goto end;
-	}
-	volume_size &= ~HAMMER2_VOLUME_ALIGNMASK64;
+	hammer2_init_volumes(devpath, 1);
 
-	best_zone = find_best_zone(fd);
+	best_zone = find_best_zone();
 	if (best_zone == -1)
 		fprintf(stderr, "Failed to find best zone\n");
 
 	if (PrintPFS) {
-		if (test_pfs_blockref(fd) == -1)
+		if (test_pfs_blockref() == -1)
 			failed = true;
 		goto end; /* print PFS info and exit */
 	}
 
 	printf("volume header\n");
-	if (test_volume_header(fd) == -1) {
+	if (test_volume_header() == -1) {
 		failed = true;
 		if (!ForceOpt)
 			goto end;
 	}
 
 	printf("freemap\n");
-	if (test_blockref(fd, HAMMER2_BREF_TYPE_FREEMAP) == -1) {
+	if (test_blockref(HAMMER2_BREF_TYPE_FREEMAP) == -1) {
 		failed = true;
 		if (!ForceOpt)
 			goto end;
 	}
 	printf("volume\n");
 	if (!ScanPFS) {
-		if (test_blockref(fd, HAMMER2_BREF_TYPE_VOLUME) == -1) {
+		if (test_blockref(HAMMER2_BREF_TYPE_VOLUME) == -1) {
 			failed = true;
 			if (!ForceOpt)
 				goto end;
 		}
 	} else {
-		if (test_pfs_blockref(fd) == -1) {
+		if (test_pfs_blockref() == -1) {
 			failed = true;
 			if (!ForceOpt)
 				goto end;
 		}
 	}
 end:
-	close(fd);
+	hammer2_cleanup_volumes();
 
 	return failed ? -1 : 0;
 }
diff --git a/sbin/hammer2/Makefile b/sbin/hammer2/Makefile
index 1ce25b6895..30b0b71dc5 100644
--- a/sbin/hammer2/Makefile
+++ b/sbin/hammer2/Makefile
@@ -1,10 +1,10 @@
 PROG=	hammer2
-SRCS=	main.c subs.c
+SRCS=	main.c subs.c ondisk.c
 SRCS+=	cmd_remote.c cmd_snapshot.c cmd_pfs.c
 SRCS+=	cmd_service.c cmd_leaf.c cmd_debug.c
 SRCS+=	cmd_rsa.c cmd_stat.c cmd_setcomp.c cmd_setcheck.c
 SRCS+=	cmd_bulkfree.c cmd_cleanup.c cmd_info.c cmd_destroy.c
-SRCS+=	cmd_emergency.c cmd_growfs.c
+SRCS+=	cmd_emergency.c cmd_growfs.c cmd_volume.c
 SRCS+=	print_inode.c
 MAN=	hammer2.8
 
diff --git a/sbin/hammer2/cmd_debug.c b/sbin/hammer2/cmd_debug.c
index 5b80ece840..527b92a9b7 100644
--- a/sbin/hammer2/cmd_debug.c
+++ b/sbin/hammer2/cmd_debug.c
@@ -379,8 +379,8 @@ cmd_debugspan(const char *hostname)
  *				    SHOW				*
  ************************************************************************/
 
-static void show_volhdr(hammer2_volume_data_t *voldata, int fd, int bi);
-static void show_bref(hammer2_volume_data_t *voldata, int fd, int tab,
+static void show_volhdr(hammer2_volume_data_t *voldata, int bi);
+static void show_bref(hammer2_volume_data_t *voldata, int tab,
 			int bi, hammer2_blockref_t *bref, int norecurse);
 static void tabprintf(int tab, const char *ctl, ...);
 
@@ -389,6 +389,23 @@ static hammer2_off_t TotalAccum64[4];
 static hammer2_off_t TotalUnavail;
 static hammer2_off_t TotalFreemap;
 
+static
+hammer2_off_t
+get_next_volume(hammer2_volume_data_t *voldata, hammer2_off_t volu_loff)
+{
+	hammer2_off_t ret = -1;
+	int i;
+
+	for (i = 0; i < HAMMER2_MAX_VOLUMES; ++i) {
+		hammer2_off_t tmp = voldata->volu_loff[i];
+		if (tmp > volu_loff) {
+			ret = tmp;
+			break;
+		}
+	}
+	return ret;
+}
+
 int
 cmd_show(const char *devpath, int which)
 {
@@ -396,6 +413,7 @@ cmd_show(const char *devpath, int which)
 	hammer2_blockref_t best;
 	hammer2_media_data_t media;
 	hammer2_media_data_t best_media;
+	hammer2_off_t off, volu_loff, next_volu_loff = 0;
 	int fd;
 	int i;
 	int best_i;
@@ -418,12 +436,11 @@ cmd_show(const char *devpath, int which)
 			show_depth = -1;
 	}
 
-	fd = open(devpath, O_RDONLY);
-	if (fd < 0) {
-		perror("open");
-		return 1;
-	}
-
+	hammer2_init_volumes(devpath, 1);
+next_volume:
+	volu_loff = next_volu_loff;
+	next_volu_loff = -1;
+	printf("%s\n", hammer2_get_volume_path(volu_loff));
 	/*
 	 * Show the tree using the best volume header.
 	 * -vvv will show the tree for all four volume headers.
@@ -434,7 +451,9 @@ cmd_show(const char *devpath, int which)
 	for (i = 0; i < HAMMER2_NUM_VOLHDRS; ++i) {
 		bzero(&broot, sizeof(broot));
 		broot.data_off = (i * HAMMER2_ZONE_BYTES64) | HAMMER2_PBUFRADIX;
-		lseek(fd, broot.data_off & ~HAMMER2_OFF_MASK_RADIX, SEEK_SET);
+		off = broot.data_off & ~HAMMER2_OFF_MASK_RADIX;
+		fd = hammer2_get_volume_fd(volu_loff);
+		lseek(fd, off, SEEK_SET);
 		if (read(fd, &media, HAMMER2_PBUFSIZE) ==
 		    (ssize_t)HAMMER2_PBUFSIZE) {
 			broot.mirror_tid = media.voldata.mirror_tid;
@@ -450,16 +469,18 @@ cmd_show(const char *devpath, int which)
 				switch(which) {
 				case 0:
 					broot.type = HAMMER2_BREF_TYPE_VOLUME;
-					show_bref(&media.voldata, fd, 0,
-						  i, &broot, 0);
+					show_bref(&media.voldata, 0, i, &broot,
+						  0);
 					break;
 				case 1:
 					broot.type = HAMMER2_BREF_TYPE_FREEMAP;
-					show_bref(&media.voldata, fd, 0,
-						  i, &broot, 0);
+					show_bref(&media.voldata, 0, i, &broot,
+						  0);
 					break;
 				default:
-					show_volhdr(&media.voldata, fd, i);
+					show_volhdr(&media.voldata, i);
+					if (i == 0)
+						next_volu_loff = get_next_volume(&media.voldata, volu_loff);
 					break;
 				}
 				if (i != HAMMER2_NUM_VOLHDRS - 1)
@@ -467,22 +488,31 @@ cmd_show(const char *devpath, int which)
 			}
 		}
 	}
+	if (next_volu_loff != (hammer2_off_t)-1) {
+		printf("---------------------------------------------\n");
+		goto next_volume;
+	}
+
 	if (VerboseOpt < 3) {
 		switch(which) {
 		case 0:
 			best.type = HAMMER2_BREF_TYPE_VOLUME;
-			show_bref(&best_media.voldata, fd, 0, best_i, &best, 0);
+			show_bref(&best_media.voldata, 0, best_i, &best, 0);
 			break;
 		case 1:
 			best.type = HAMMER2_BREF_TYPE_FREEMAP;
-			show_bref(&best_media.voldata, fd, 0, best_i, &best, 0);
+			show_bref(&best_media.voldata, 0, best_i, &best, 0);
 			break;
 		default:
-			show_volhdr(&best_media.voldata, fd, best_i);
+			show_volhdr(&best_media.voldata, best_i);
+			next_volu_loff = get_next_volume(&best_media.voldata, volu_loff);
+			if (next_volu_loff != (hammer2_off_t)-1) {
+				printf("---------------------------------------------\n");
+				goto next_volume;
+			}
 			break;
 		}
 	}
-	close(fd);
 
 	if (which == 1 && VerboseOpt < 3) {
 		printf("Total unallocated storage:   %6.3fGiB (%6.3fGiB in 64KB chunks)\n",
@@ -499,17 +529,19 @@ cmd_show(const char *devpath, int which)
 		printf("Total freemap storage:       %6.3fGiB\n",
 		       (double)TotalFreemap / GIG);
 	}
+	hammer2_cleanup_volumes();
 
 	return 0;
 }
 
 static void
-show_volhdr(hammer2_volume_data_t *voldata, int fd, int bi)
+show_volhdr(hammer2_volume_data_t *voldata, int bi)
 {
 	uint32_t status;
 	uint32_t i;
 	char *str;
 	char *name;
+	char *buf;
 
 	printf("\nVolume header %d {\n", bi);
 	printf("    magic          0x%016jx\n", (intmax_t)voldata->magic);
@@ -531,6 +563,8 @@ show_volhdr(hammer2_volume_data_t *voldata, int fd, int bi)
 	printf("    copyid         %d\n", voldata->copyid);
 	printf("    freemap_vers   %d\n", voldata->freemap_version);
 	printf("    peer_type      %d\n", voldata->peer_type);
+	printf("    volu_id        %d\n", voldata->volu_id);
+	printf("    nvolumes       %d\n", voldata->nvolumes);
 
 	str = NULL;
 	hammer2_uuid_to_str(&voldata->fsid, &str);
@@ -567,6 +601,7 @@ show_volhdr(hammer2_volume_data_t *voldata, int fd, int bi)
 		printf("    reserved00A0/%u 0x%016jx\n",
 		       i, voldata->reserved00A0[0]);
 	}
+	printf("    total_size     0x%016jx\n", voldata->total_size);
 
 	printf("    copyexists    ");
 	for (i = 0; i < nitems(voldata->copyexists); ++i)
@@ -641,29 +676,40 @@ show_volhdr(hammer2_volume_data_t *voldata, int fd, int bi)
 	printf("\n");
 	printf("    sroot_blockset {\n");
 	for (i = 0; i < HAMMER2_SET_COUNT; ++i) {
-		show_bref(voldata, fd, 16, i,
+		show_bref(voldata, 16, i,
 			  &voldata->sroot_blockset.blockref[i], 2);
 	}
 	printf("    }\n");
 
 	printf("    freemap_blockset {\n");
 	for (i = 0; i < HAMMER2_SET_COUNT; ++i) {
-		show_bref(voldata, fd, 16, i,
+		show_bref(voldata, 16, i,
 			  &voldata->freemap_blockset.blockref[i], 2);
 	}
 	printf("    }\n");
 
+	buf = calloc(1, sizeof(voldata->volu_loff));
+	if (bcmp(buf, voldata->volu_loff, sizeof(voldata->volu_loff))) {
+		printf("\n");
+		for (i = 0; i < HAMMER2_MAX_VOLUMES; ++i) {
+			hammer2_off_t loff = voldata->volu_loff[i];
+			if (loff != (hammer2_off_t)-1)
+				printf("    volu_loff[%d]   0x%016jx\n", i, loff);
+		}
+	}
+	free(buf);
+
 	printf("}\n");
 }
 
 static void
-show_bref(hammer2_volume_data_t *voldata, int fd, int tab,
-	  int bi, hammer2_blockref_t *bref, int norecurse)
+show_bref(hammer2_volume_data_t *voldata, int tab, int bi,
+	  hammer2_blockref_t *bref, int norecurse)
 {
 	hammer2_media_data_t media;
 	hammer2_blockref_t *bscan;
 	hammer2_off_t tmp;
-	int i, bcount, namelen, failed, obrace;
+	int i, bcount, namelen, failed, obrace, fd;
 	int type_pad;
 	size_t bytes;
 	const char *type_str;
@@ -703,7 +749,9 @@ show_bref(hammer2_volume_data_t *voldata, int fd, int tab,
 			return;
 		}
 		if (bref->type != HAMMER2_BREF_TYPE_DATA || VerboseOpt >= 1) {
-			lseek(fd, io_base, SEEK_SET);
+			fd = hammer2_get_volume_fd(io_off);
+			lseek(fd, io_base - hammer2_get_volume_offset(io_base),
+			      SEEK_SET);
 			if (read(fd, &media, io_bytes) != (ssize_t)io_bytes) {
 				printf("(media read failed)\n");
 				return;
@@ -755,9 +803,10 @@ show_bref(hammer2_volume_data_t *voldata, int fd, int tab,
 	if (QuietOpt > 0) {
 		tabprintf(tab,
 			  "%s.%-3d %016jx %016jx/%-2d "
-			  "mir=%016jx mod=%016jx leafcnt=%d ",
+			  "vol=%d mir=%016jx mod=%016jx leafcnt=%d ",
 			  type_str, bi, (intmax_t)bref->data_off,
 			  (intmax_t)bref->key, (intmax_t)bref->keybits,
+			  hammer2_get_volume_id(bref->data_off),
 			  (intmax_t)bref->mirror_tid,
 			  (intmax_t)bref->modify_tid,
 			  bref->leaf_count);
@@ -770,7 +819,8 @@ show_bref(hammer2_volume_data_t *voldata, int fd, int tab,
 			printf("\n");
 			tabprintf(tab + 13, "");
 		}
-		printf("mir=%016jx mod=%016jx lfcnt=%d ",
+		printf("vol=%d mir=%016jx mod=%016jx lfcnt=%d ",
+		       hammer2_get_volume_id(bref->data_off),
 		       (intmax_t)bref->mirror_tid, (intmax_t)bref->modify_tid,
 		       bref->leaf_count);
 		if (/*norecurse > 1 && */ (bcount || bref->flags ||
@@ -1079,7 +1129,7 @@ show_bref(hammer2_volume_data_t *voldata, int fd, int tab,
 			hammer2_off_t data_off = bref->key +
 				i * HAMMER2_FREEMAP_LEVEL0_SIZE;
 			if (data_off >= voldata->aux_end &&
-			    data_off < voldata->volu_size) {
+			    data_off < hammer2_get_total_size()) {
 				int j;
 				for (j = 0; j < 4; ++j)
 					CountBlocks(&media.bmdata[i], j,
@@ -1103,7 +1153,7 @@ show_bref(hammer2_volume_data_t *voldata, int fd, int tab,
 	if (show_depth == -1 || ((tab - init_tab) / show_tab) < show_depth) {
 		for (i = 0; norecurse == 0 && i < bcount; ++i) {
 			if (bscan[i].type != HAMMER2_BREF_TYPE_EMPTY) {
-				show_bref(voldata, fd, tab, i, &bscan[i],
+				show_bref(voldata, tab, i, &bscan[i],
 				    failed);
 			}
 		}
diff --git a/sbin/hammer2/cmd_info.c b/sbin/hammer2/cmd_info.c
index 6bb9d48a35..92b1c4ab1a 100644
--- a/sbin/hammer2/cmd_info.c
+++ b/sbin/hammer2/cmd_info.c
@@ -308,6 +308,7 @@ h2disk_check(const char *devpath, cmd_callback callback1)
 	hammer2_blockref_t broot;
 	hammer2_blockref_t best;
 	hammer2_media_data_t media;
+	hammer2_volume_data_t *voldata;
 	struct partinfo partinfo;
 	int fd;
 	int i;
@@ -352,14 +353,19 @@ h2disk_check(const char *devpath, cmd_callback callback1)
 		broot.data_off = (i * HAMMER2_ZONE_BYTES64) |
 				 HAMMER2_PBUFRADIX;
 		lseek(fd, broot.data_off & ~HAMMER2_OFF_MASK_RADIX, SEEK_SET);
-		if (read(fd, &media, HAMMER2_PBUFSIZE) ==
-		    (ssize_t)HAMMER2_PBUFSIZE &&
-		    media.voldata.magic == HAMMER2_VOLUME_ID_HBO) {
-			broot.mirror_tid = media.voldata.mirror_tid;
-			if (best_i < 0 || best.mirror_tid < broot.mirror_tid) {
-				best_i = i;
-				best = broot;
-			}
+		if (read(fd, &media, HAMMER2_PBUFSIZE) !=
+		    (ssize_t)HAMMER2_PBUFSIZE)
+			continue;
+		voldata = &media.voldata;
+		if (voldata->magic != HAMMER2_VOLUME_ID_HBO)
+			continue;
+		/* XXX multiple volumes currently unsupported */
+		if (voldata->nvolumes > 1)
+			break;
+		broot.mirror_tid = voldata->mirror_tid;
+		if (best_i < 0 || best.mirror_tid < broot.mirror_tid) {
+			best_i = i;
+			best = broot;
 		}
 	}
 	if (best_i >= 0)
diff --git a/sbin/hammer2/cmd_volume.c b/sbin/hammer2/cmd_volume.c
new file mode 100644
index 0000000000..cf47c199e4
--- /dev/null
+++ b/sbin/hammer2/cmd_volume.c
@@ -0,0 +1,106 @@
+/*
+ * Copyright (c) 2020 Tomohiro Kusumi <tkusumi@netbsd.org>
+ * Copyright (c) 2020 The DragonFly Project
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The DragonFly Project
+ * by Matthew Dillon <dillon@dragonflybsd.org>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ * 3. Neither the name of The DragonFly Project nor the names of its
+ *    contributors may be used to endorse or promote products derived
+ *    from this software without specific, prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
+ * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
+ * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
+ * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+ * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+ * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include "hammer2.h"
+
+int
+cmd_volume_list(int ac, char **av)
+{
+	hammer2_ioc_volume_list_t vollist;
+	hammer2_ioc_volume_t *entry;
+	int fd, i, j, n, w, all = 0, ecode = 0;
+
+	if (ac == 1 && av[0] == NULL) {
+		av = get_hammer2_mounts(&ac);
+		all = 1;
+	}
+	vollist.volumes = calloc(HAMMER2_MAX_VOLUMES, sizeof(*vollist.volumes));
+
+	for (i = 0; i < ac; ++i) {
+		if (i)
+			printf("\n");
+		if (ac > 1 || all)
+			printf("%s\n", av[i]);
+		if ((fd = hammer2_ioctl_handle(av[i])) < 0) {
+			ecode = 1;
+			goto failed;
+		}
+
+		vollist.nvolumes = HAMMER2_MAX_VOLUMES;
+		if (ioctl(fd, HAMMER2IOC_VOLUME_LIST, &vollist) < 0) {
+			perror("ioctl");
+			close(fd);
+			ecode = 1;
+			goto failed;
+		}
+
+		w = 0;
+		for (j = 0; j < vollist.nvolumes; ++j) {
+			entry = &vollist.volumes[j];
+			n = (int)strlen(entry->path);
+			if (n > w)
+				w = n;
+		}
+
+		if (QuietOpt > 0) {
+			for (j = 0; j < vollist.nvolumes; ++j) {
+				entry = &vollist.volumes[j];
+				printf("%s\n", entry->path);
+			}
+		} else {
+			printf("version %d\n", vollist.version);
+			printf("@%s\n", vollist.pfs_name);
+			for (j = 0; j < vollist.nvolumes; ++j) {
+				entry = &vollist.volumes[j];
+				printf("volume%-2d %-*.*s %s",
+				       entry->id, w, w, entry->path,
+				       sizetostr(entry->size));
+				if (VerboseOpt > 0)
+					printf(" 0x%016jx 0x%016jx",
+					       (intmax_t)entry->offset,
+					       (intmax_t)entry->size);
+				printf("\n");
+			}
+		}
+		close(fd);
+	}
+failed:
+	free(vollist.volumes);
+	if (all)
+		put_hammer2_mounts(ac, av);
+
+	return (ecode);
+}
diff --git a/sbin/hammer2/hammer2.h b/sbin/hammer2/hammer2.h
index 498bd890ee..a885cee7e1 100644
--- a/sbin/hammer2/hammer2.h
+++ b/sbin/hammer2/hammer2.h
@@ -155,6 +155,7 @@ int cmd_emergency_mode(const char *sel_path, int enable,
 			int ac, const char **av);
 int cmd_growfs(const char *sel_path, int ac, const char **av);
 int cmd_show(const char *devpath, int which);
+int cmd_volume_list(int ac, char **av);
 int cmd_rsainit(const char *dir_path);
 int cmd_rsaenc(const char **keys, int nkeys);
 int cmd_rsadec(const char **keys, int nkeys);
diff --git a/sbin/hammer2/hammer2_subs.h b/sbin/hammer2/hammer2_subs.h
index 81cc432422..f2f20116d9 100644
--- a/sbin/hammer2/hammer2_subs.h
+++ b/sbin/hammer2/hammer2_subs.h
@@ -40,6 +40,24 @@
 
 #include <vfs/hammer2/hammer2_disk.h>
 
+typedef struct hammer2_volume {
+	int fd;
+	int id;
+	char *path;
+	hammer2_off_t offset;
+	hammer2_off_t size;
+} hammer2_volume_t;
+
+typedef struct hammer2_ondisk {
+	int version;
+	int nvolumes;
+	hammer2_volume_t volumes[HAMMER2_MAX_VOLUMES];
+	hammer2_off_t total_size;
+	hammer2_off_t free_size;
+	uuid_t fsid;
+	uuid_t fstype;
+} hammer2_ondisk_t;
+
 /*
  * Misc functions
  */
@@ -52,6 +70,7 @@ const char *hammer2_pfssubtype_to_str(uint8_t subtype);
 const char *hammer2_breftype_to_str(uint8_t type);
 const char *sizetostr(hammer2_off_t size);
 const char *counttostr(hammer2_off_t size);
+hammer2_off_t check_volume(int fd);
 hammer2_key_t dirhash(const unsigned char *name, size_t len);
 
 #define hammer2_icrc32(buf, size)	iscsi_crc32((buf), (size))
@@ -62,4 +81,28 @@ uint32_t iscsi_crc32_ext(const void *buf, size_t size, uint32_t ocrc);
 char **get_hammer2_mounts(int *acp);
 void put_hammer2_mounts(int ac, char **av);
 
+void hammer2_init_ondisk(hammer2_ondisk_t *fsp);
+void hammer2_install_volume(hammer2_volume_t *vol, int fd, int id,
+	const char *path, hammer2_off_t offset, hammer2_off_t size);
+void hammer2_uninstall_volume(hammer2_volume_t *vol);
+void hammer2_verify_volumes(hammer2_ondisk_t *fsp,
+	const hammer2_volume_data_t *rootvoldata);
+void hammer2_print_volumes(const hammer2_ondisk_t *fsp);
+void hammer2_init_volumes(const char *blkdevs, int rdonly);
+void hammer2_cleanup_volumes(void);
+
+int hammer2_get_volume_fd(hammer2_off_t offset);
+int hammer2_get_root_volume_fd(void);
+int hammer2_get_volume_id(hammer2_off_t offset);
+int hammer2_get_root_volume_id(void);
+const char *hammer2_get_volume_path(hammer2_off_t offset);
+const char *hammer2_get_root_volume_path(void);
+hammer2_off_t hammer2_get_volume_offset(hammer2_off_t offset);
+hammer2_off_t hammer2_get_root_volume_offset(void);
+hammer2_off_t hammer2_get_volume_size(hammer2_off_t offset);
+hammer2_off_t hammer2_get_root_volume_size(void);
+
+hammer2_off_t hammer2_get_total_size(void);
+hammer2_volume_data_t* hammer2_read_root_volume_header(void);
+
 #endif /* !HAMMER2_HAMMER2_SUBS_H_ */
diff --git a/sbin/hammer2/main.c b/sbin/hammer2/main.c
index fbd62194e5..fd072ee2bd 100644
--- a/sbin/hammer2/main.c
+++ b/sbin/hammer2/main.c
@@ -437,6 +437,16 @@ main(int ac, char **av)
 		} else {
 			cmd_show(av[1], 2);
 		}
+	} else if (strcmp(av[0], "volume-list") == 0) {
+		/*
+		 * List all volumes
+		 */
+		if (ac >= 2) {
+			ecode = cmd_volume_list(ac - 1,
+					     (char **)(void *)&av[1]);
+		} else {
+			ecode = cmd_volume_list(1, &sel_path);
+		}
 	} else if (strcmp(av[0], "setcomp") == 0) {
 		if (ac < 3) {
 			/*
@@ -593,6 +603,8 @@ usage(int code)
 			"Raw hammer2 media dump for freemap\n"
 		"    volhdr <devpath>                  "
 			"Raw hammer2 media dump for the volume header(s)\n"
+		"    volume-list [<path>...]           "
+			"List volumes\n"
 		"    setcomp <comp[:level]> <path>...  "
 			"Set comp algo {none, autozero, lz4, zlib} & level\n"
 		"    setcheck <check> <path>...        "
